from zencad import *
import math

r = 20 # Внутренний радиус секции (см. основание)
R = 40 # Внешний радиус секции (см. основание)
d = 2 # Толщина стенок
hc = 40 # Высота воронки
Rc = 6.5 # Внешний радиус воронки
rc = Rc - d # Внутренний радиус воронки
ra = 2.1 # Внутренний радиус шестерни
ha = 4
Na = 20 # Количество зубьев шестеренки на оси мотора
Rp = 2.5 # Внешний радиус гусака
rp = 1.5 # Внутренний радиус гусака

# Делаем шестеренку двигателя сервы
a = 2*math.pi*ra/Na
Ra = ra + (a/2)*math.tan(deg(60))
wrk = ngon(r=Ra, n=3)
wrk -= box(2*Ra, center=True).moveX(-Ra)
kink = wrk.extrude(ha) # Зубчик шестеренки двигателя сервы
gear = unify(rotate_array(n=Na)(kink)).rotZ(deg(180/Na)) # Сама шестеренка
# Делаем гусака без дырки
points = [(0, 0, 0), ((R+r)/2, 0, -(14+d+1.5-1))] # Опорные точки
tangs = [(1, 0, 0), (0, 0, -1)] # Векторы касательных к точкам
spine = interpolate(points, tangs) # Траектория экструзии гусака
pr1 = circle(r=Rp).rotY(deg(90)) # 
pipe = pipe_shell(profiles=[pr1], spine=spine) # Гусак без дырки
pipe = pipe.moveZ(ha+d+rp) # Смещаем гусака по Z в нужное место
# Делаем собственно саму лейку
modela = cylinder(r=Rc, h=hc) - gear + pipe # Заготовка лейки
modela -= cylinder(r=rc, h=hc).moveZ(ha+d) # Основное отверстие
# "Сверлим" дырку в гусаке 
pr2 = circle(r=rp).rotY(deg(90)) 
m2 = pipe_shell(profiles=[pr2], spine=spine).moveZ(ha+d+rp)
modela -= m2
modela = unify(modela)
modela = modela.rotX(deg(180)).moveZ(hc)
#disp(modela - halfspace().rotateX(deg(-90)))
#disp(modela)
disp(modela-halfspace().rotateX(deg(-90)))
show()
